#include "StdAfx.h"
#include "httpfacade.h"
#include <algorithm>
#include "GameTalkAPIGlobal.h"

#define WM_HTTPCOMPLETED		(WM_USER + 1600)


// static 
CHttpFacadeHelperWnd * CHttpFacade::ms_pAsyncEventRelayWnd = NULL;		// 踦 ѱ   ޽ 


////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CHttpFacadeHelperWnd 

CHttpFacadeHelperWnd::CHttpFacadeHelperWnd() : m_nTimerID_Serial(100)
{
#if defined(WIN32) // __KEH_USE_LKWND__
	m_pWnd = CreateTinyWindow();
	m_pWnd->SetEvents(this);
	m_pWnd->Create(NULL);
#else
	m_pEventDelegate = CreateEventDelegate(NULL);
	m_pEventDelegate->RegisterObserver(this);
#endif	
}


CHttpFacadeHelperWnd::~CHttpFacadeHelperWnd()
{
#if defined(WIN32) // __KEH_USE_LKWND__	
	m_pWnd->Delete();
#else	
	m_pEventDelegate->UnRegisterObserver(this);
	m_pEventDelegate->Delete();
	m_pEventDelegate = NULL;
#endif	
}



bool CHttpFacadeHelperWnd::OnSignalProcess(int nMsg, WPARAM wParam, LPARAM lParam)
{
	switch(nMsg)
	{
		case WM_HTTPCOMPLETED:
			{
			CHttpFacade * pHttpFacade = (CHttpFacade *)wParam;
			
			// ޽ ť óǴµ CHttpFacade ü ̹ delete Ǿ ִ.
			//  ⼭  ʼ!!!
			std::list<CHttpFacade*>::iterator it = find(m_listHttpFacade.begin(), 
				                                        m_listHttpFacade.end(), 
														pHttpFacade );
			
			if(it != m_listHttpFacade.end() )
			{
				if( pHttpFacade->m_bStopped == false )
				{
					pHttpFacade->m_bStopped = true;
					
					if(GT_GLOBAL->IsAvailableAPI() )
						pHttpFacade->m_pEvent->OnHttpCompleted( pHttpFacade, lParam == 1 ? true : false, false);
					
					//  ؿ  pHttpFacade ü  !!!
					//  OnHttpCompleted Լȿ ڱڽ ü ŵ  .
					if(CHttpFacade::ms_pAsyncEventRelayWnd == NULL)
						return true;
				}
			}
			}
			break;
			
		default:
			return false;
	}
	return true;
}


bool CHttpFacadeHelperWnd::OnTimerProcess(WPARAM wParam, LPARAM lParam)
{	
	TIMER_KILL(wParam);
		
	std::list<CHttpFacade*>::iterator it = m_listHttpFacade.begin();
	for ( ; it != m_listHttpFacade.end() ; it++)
	{
		CHttpFacade * pHttpFacade = *it;
			
		if( pHttpFacade->m_nHttpTimeOut_TimerID == wParam )
		{
			if( pHttpFacade->m_bStopped == false )
			{
				pHttpFacade->OnTimeOut();
			}
			break;
		}
	}
	
	return false;
}

#if defined(WIN32) //__KEH_USE_LKWND__
BOOL CHttpFacadeHelperWnd::ITinyWindow_OnWndProc(ITinyWindow * pWindow, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if(uMsg != WM_TIMER)
		return OnSignalProcess(uMsg, wParam, lParam) ? TRUE : FALSE;
	else
		return OnTimerProcess(wParam, lParam) ? TRUE : FALSE;
}
#else
bool CHttpFacadeHelperWnd::OnGTRunLoopObserver_SourceEvent(GT_EVENT_HANDLE handle, GT_PARAM param1, GT_PARAM param2)
{
	OnSignalProcess(handle, (WPARAM)param1, (LPARAM)param2);
	return true;
}


bool CHttpFacadeHelperWnd::OnGTRunLoopObserver_TimerEvent(GT_EVENT_HANDLE handle, GT_PARAM param)
{
	OnTimerProcess(handle, (LPARAM)param);
	return true;
}
#endif

void CHttpFacadeHelperWnd::SetHttpFacadeTimer(CHttpFacade * pHttpFacade, int nElapse)
{
	//  ִ Ÿ̸Ӹ Ѵ.
	if( pHttpFacade->m_nHttpTimeOut_TimerID )
	{
		TIMER_KILL(pHttpFacade->m_nHttpTimeOut_TimerID);
	}

	pHttpFacade->m_nHttpTimeOut_TimerID = m_nTimerID_Serial++;

	TIMER_START(pHttpFacade->m_nHttpTimeOut_TimerID, nElapse, NULL );
}


void CHttpFacadeHelperWnd::KillHttpFacadeTimer(CHttpFacade * pHttpFacade)
{
	if( pHttpFacade->m_nHttpTimeOut_TimerID )
	{
		TIMER_KILL(pHttpFacade->m_nHttpTimeOut_TimerID );
		pHttpFacade->m_nHttpTimeOut_TimerID = 0;
	}
}



/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CHttpFacade
CHttpFacade::CHttpFacade(void)
{
	m_nHttpReqTimeoutElapse = 0;
	m_nHttpTimeOut_TimerID = 0;

	if( ms_pAsyncEventRelayWnd == NULL )
	{
		ms_pAsyncEventRelayWnd = new CHttpFacadeHelperWnd;
	}

	if (NULL != ms_pAsyncEventRelayWnd)
		ms_pAsyncEventRelayWnd->m_listHttpFacade.push_back( this );

	m_pEvent = NULL;
	m_bStopped = false;
	m_bWorking = false;
	m_http.SetEvents(this);
}

CHttpFacade::~CHttpFacade(void)
{
//	DLOG("CHttpFacade::~CHttpFacade(void)\n");
	
	m_http.StopRequest();
	
	// α. 424 0x00449d76ũ Ʈ 
	// ms_pAsyncEventRelayWnd ϴٰ INVALID_POINTER_READ  ״ 찡 ֱ 
	// ϴ  üũ ó ߰Ͽ ¸ Ѻ մϴ.
	if(ms_pAsyncEventRelayWnd == NULL) /*  Return BY SDK*/
		return; 


	std::list<CHttpFacade*>::iterator it = find(ms_pAsyncEventRelayWnd->m_listHttpFacade.begin(), ms_pAsyncEventRelayWnd->m_listHttpFacade.end(), this );
	
	if(it != ms_pAsyncEventRelayWnd->m_listHttpFacade.end() )
	{
		ms_pAsyncEventRelayWnd->m_listHttpFacade.erase(it);

		int nSize = ms_pAsyncEventRelayWnd->m_listHttpFacade.size();
		if(nSize == 0 )
		{
			delete ms_pAsyncEventRelayWnd;//->DestroyWindow();
			ms_pAsyncEventRelayWnd = NULL;
		}
	}
}

bool CHttpFacade::GetProgressInfo(size_t &totalSize, size_t &currentSize)
{
    return m_http.GetProgressInfo(totalSize, currentSize);
}


bool CHttpFacade::SendRequest(_IHttpFacadeEvent * pResultEventReceiver, int nTimeoutElapse)
{
	bool bSendResult = false;

	m_bWorking = true;
	ms_pAsyncEventRelayWnd->KillHttpFacadeTimer( this );

	m_nHttpReqTimeoutElapse = nTimeoutElapse;

	if( m_nHttpReqTimeoutElapse != 0 )
		ms_pAsyncEventRelayWnd->SetHttpFacadeTimer( this, m_nHttpReqTimeoutElapse );

	m_pEvent = pResultEventReceiver;

	m_http.StopRequest();

	m_bStopped = false;
	m_strNPhoneResultCode = "";

	bSendResult = m_http.SendRequest();

//	m_log.Clear();
//	m_log.Trace("GBL <S-%04d> %s : REQUEST", m_trid.GetID(), session().GetURL());

	return bSendResult;
}

void CHttpFacade::StopRequest()
{
	m_http.StopRequest();
	m_bStopped = true;
	m_bWorking = false;
}


// _IHttpSessionEvents
void CHttpFacade::On_Http_SendProgress(IHttpSession * pSession, DWORD dwTotalSize, DWORD dwCurrentSize)
{
	if(m_pEvent)
		m_pEvent->OnHttpProgress(this,  dwTotalSize, dwCurrentSize);
}


void CHttpFacade::On_Http_ReceiveProgress(IHttpSession * /*pSession*/, DWORD /*dwTotalSize*/, DWORD /*dwCurrentSize*/)
{
}


void CHttpFacade::On_Http_Completed(IHttpSession * /*pSession*/, bool bSuccess)
{
	if( m_bStopped )
	{
		m_bWorking = false;
		return;
	}

	GT_ASSERT( m_bStopped == false );

	ms_pAsyncEventRelayWnd->KillHttpFacadeTimer( this );

#define NPHONE_WSA_RESULTCODE_KEYWORD		"nphone-resultcode:"

	m_strNPhoneResultCode = "";		// ʱȭ
	const char * pszRawHeader = m_http.GetRawHeader();
	if( pszRawHeader )
	{
		const char * pKeywordPos = strstr( pszRawHeader, NPHONE_WSA_RESULTCODE_KEYWORD );
		if( pKeywordPos )
		{
			pKeywordPos += strlen( NPHONE_WSA_RESULTCODE_KEYWORD );

			while( (*pKeywordPos == ' ' || *pKeywordPos == '\t') &&
				*pKeywordPos != '\0' &&
				*pKeywordPos != '\n')
				pKeywordPos++;

			const char * pKeywordPos2 = strchr( pKeywordPos, '\n' );
			if( pKeywordPos2 == NULL )
				pKeywordPos2 = strchr( pKeywordPos, '\r' );

			if( pKeywordPos2 == NULL )
			{
				m_strNPhoneResultCode = pKeywordPos;
			}
			else
			{
				const char * pKeywordPos3 = strchr( pKeywordPos, '\r' );
				if( pKeywordPos3 != NULL && pKeywordPos3 < pKeywordPos2 )
					pKeywordPos2 = pKeywordPos3;

				m_strNPhoneResultCode.assign( pKeywordPos, pKeywordPos2 );
			}
		}
	}

#if defined(WIN32)
	SIGNAL_PERFORM_TARGET(ms_pAsyncEventRelayWnd->GetHwnd(), WM_HTTPCOMPLETED, (WPARAM)this, bSuccess ? 1 : 0);
#else	
	SIGNAL_PERFORM_TARGET(ms_pAsyncEventRelayWnd->GetDelegate(), WM_HTTPCOMPLETED, (WPARAM)this, (LPARAM)(bSuccess ? 1 : 0));
#endif	
}

void CALLBACK CHttpFacade::OnTimeOut()
{
	StopRequest();

	if(GT_GLOBAL->IsAvailableAPI())
		m_pEvent->OnRequestTimeout( this, m_nHttpReqTimeoutElapse);
}

